"use strict";

var _dogmalang = require("dogmalang");

const DFLT_DB_IMPL = "#postgresql";const DFLT_CACHE_IMPL = "#postgresql";const DFLT_Q_IMPL = "#postgresql";const DFLT_LOGGER_IMPL = "#dummy";const DFLT_TMPL_IMPL = "#handlebars";
const $ServerDataCxnComp = class ServerDataCxnComp {
  constructor() {
    this._constructor(...arguments);
  }_constructor() {
    {}
  }
};
const ServerDataCxnComp = new Proxy($ServerDataCxnComp, { apply(receiver, self, args) {
    /* istanbul ignore next */throw "'ServerDataCxnComp' is abstract.";
  } });module.exports = exports = ServerDataCxnComp;
ServerDataCxnComp.prototype._startLoggerCxn = async function () {
  {
    if ((this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).logger : null) {
      let Logger;{
        const _ = this._props.conn.logger.impl || DFLT_LOGGER_IMPL;switch (_) {case "#console":
            {
              Logger = _dogmalang.dogma.use(require("justows.conn.log.console"));
            }; /* istanbul ignore next */break;case "#dummy":
            {
              Logger = _dogmalang.dogma.use(require("justows.conn.log.dummy"));
            }; /* istanbul ignore next */break;case "#postgresql":
            {
              Logger = _dogmalang.dogma.use(require("justows.conn.log.postgres"));
            }; /* istanbul ignore next */break;case "#redis":
            {
              Logger = _dogmalang.dogma.use(require("justows.conn.log.redis"));
            }; /* istanbul ignore next */break;case "#zeromq":
            {
              Logger = _dogmalang.dogma.use(require("justows.conn.log.zeromq"));
            }; /* istanbul ignore next */break;default:
            {
              if (_) {
                return rej((0, _dogmalang.fmt)("invalid logger.impl: %s.", _));
              }
            }}
      }await (this._ownLogger = Logger(this._props.conn.logger)).start();
    }
  }
};
ServerDataCxnComp.prototype._stopLoggerCxn = async function () {
  {
    if (this._ownLogger) {
      await this._ownLogger.stop();this._ownLogger = null;
    }
  }
};
ServerDataCxnComp.prototype._startTmplCxn = async function () {
  {
    {
      const props = (this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).tmpl : null;if (props) {
        {
          const _ = this._props.conn.tmpl.impl || DFLT_TMPL_IMPL;switch (_) {case "#handlebars":
              {
                await this._pvt_b75a79a7e7aaf015964b5195f6395822_startHandlebarsTmpl(props);
              }; /* istanbul ignore next */break;default:
              {
                _dogmalang.dogma.raise("invalid db.impl: %s.", _);
              }}
        }
      }
    }
  }
};
ServerDataCxnComp.prototype._pvt_b75a79a7e7aaf015964b5195f6395822_startHandlebarsTmpl = async function (props) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, null);{
    this._ownTmpl = _dogmalang.dogma.use(require("justows.conn.tmpl.handlebars"))(props);
  }
};
ServerDataCxnComp.prototype._stopTmplCxn = async function () {
  {
    if (this._ownTmpl) {
      await this._ownTmpl.stop();
    }
  }
};
ServerDataCxnComp.prototype._startSmtpCxn = async function () {
  {
    {
      const props = (this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).smtp : null;if (props) {
        await (this._ownSmtp = _dogmalang.dogma.use(require("justows.conn.smtp")).AsyncSmtpConn(props)).start();
      }
    }
  }
};
ServerDataCxnComp.prototype._stopSmtpCxn = async function () {
  {
    if (this._ownSmtp) {
      await this._ownSmtp.stop();this._ownSmtp = null;
    }
  }
};
ServerDataCxnComp.prototype._startDbCxn = async function () {
  {
    if ((this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).db : null) {
      let db = this._props.conn.db.impl || DFLT_DB_IMPL;{
        const _ = db;switch (_) {case "#postgresql":
            {
              await this._pvt_b75a79a7e7aaf015964b5195f6395822_startPostgresDb();
            }; /* istanbul ignore next */break;default:
            {
              _dogmalang.dogma.raise("invalid db.impl: %s.", _);
            }}
      }
    }
  }
};
ServerDataCxnComp.prototype._stopDbCxn = async function () {
  {
    if (this._ownDb) {
      await this._pvt_b75a79a7e7aaf015964b5195f6395822_stopPostgresDb();
    }
  }
};
ServerDataCxnComp.prototype._pvt_b75a79a7e7aaf015964b5195f6395822_startPostgresDb = async function () {
  {
    await (this._ownDb = _dogmalang.dogma.use(require("justows.conn.db.postgres"))(this._props.conn.db)).start();
  }
};ServerDataCxnComp.prototype._pvt_b75a79a7e7aaf015964b5195f6395822_stopPostgresDb = async function () {
  {
    await this._ownDb.stop();this._ownDb = null;
  }
};
ServerDataCxnComp.prototype._startCacheCxn = async function () {
  {
    if ((this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).cache : null) {
      let cache = this._props.conn.cache.impl || DFLT_CACHE_IMPL;{
        const _ = cache;switch (_) {case "#postgresql":
            {
              cache = "justows.conn.cache.postgres";
            }; /* istanbul ignore next */break;case "#pouchdb":
            {
              cache = "justows.conn.cache.pouchdb";
            }; /* istanbul ignore next */break;case "#redis":
            {
              cache = "justows.conn.cache.redis";
            }; /* istanbul ignore next */break;default:
            {
              _dogmalang.dogma.raise("invalid cache.impl: %s.", _);
            }}
      }await (this._ownCache = _dogmalang.dogma.use(require(cache))(this._props.conn.cache)).start();
    }
  }
};
ServerDataCxnComp.prototype._stopCacheCxn = async function () {
  {
    if (this._ownCache) {
      await this._ownCache.stop();this._ownCache = null;
    }
  }
};
ServerDataCxnComp.prototype._startQCxn = async function () {
  {
    if ((this._props != null ? this._props.conn : null) != null ? (this._props != null ? this._props.conn : null).q : null) {
      let q = this._props.conn.q.impl || DFLT_Q_IMPL;{
        const _ = q;switch (_) {case "#redis":
            {
              q = "justows.conn.q.redis";
            }; /* istanbul ignore next */break;case "#postgresql":
            {
              q = "justows.conn.q.postgres";
            }; /* istanbul ignore next */break;case "#zeromq":
            {
              q = "justows.conn.q.zeromq";
            }; /* istanbul ignore next */break;default:
            {
              _dogmalang.dogma.raise("invalid q.impl: %s.", _);
            }}
      }await (this._ownQ = _dogmalang.dogma.use(require(q))(this._props.conn.q)).start();
    }
  }
};
ServerDataCxnComp.prototype._stopQCxn = async function () {
  {
    if (this._ownQ) {
      await this._ownQ.stop();this._ownQ = null;
    }
  }
};