"use strict";

var _dogmalang = require("dogmalang");

var _justows = require("justows.common");

const ServerDataCxnComp = _dogmalang.dogma.use(require("./ServerDataCxnComp"));
const ServerEServer = _dogmalang.dogma.use(require("./e/ServerEServer"));const ConHttpServer = _dogmalang.dogma.use(require("./http/ConHttpServer"));const ServerJobServer = _dogmalang.dogma.use(require("./job/ServerJobServer"));const ServerQServer = _dogmalang.dogma.use(require("./q/ServerQServer"));const WsWebQServer = _dogmalang.dogma.use(require("./webq/WsWebQServer"));const ServerRepoServer = _dogmalang.dogma.use(require("./repo/ServerRepoServer"));
const $ServerSuperServer = class ServerSuperServer extends _justows.SuperServer {
  constructor(props) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpected("props", props, _dogmalang.map);super(...arguments); /* istanbul ignore next */if (ServerDataCxnComp.prototype._constructor instanceof Function) ServerDataCxnComp.prototype._constructor.bind(this)();{
      const srv = props.servers || {};_dogmalang.dogma.update(this, { name: "repoServer", visib: ":", assign: ":=", value: ServerRepoServer(this, srv.repo || {}) });_dogmalang.dogma.update(this, { name: "repo", visib: ".", assign: ":=", value: this._repoServer.repo });_dogmalang.dogma.update(this, { name: "eServer", visib: ":", assign: ":=", value: ServerEServer(this, srv.e || {}) });_dogmalang.dogma.update(this, { name: "e", visib: ".", assign: ":=", value: (0, _justows.EConn)(this._eServer) });if (srv.http) {
        _dogmalang.dogma.update(this, { name: "httpServer", visib: ":", assign: ":=", value: ConHttpServer(this, srv.http) });
      }if (srv.webQ) {
        _dogmalang.dogma.update(this, { name: "webQServer", visib: ":", assign: ":=", value: WsWebQServer(this, srv.webQ) });
      }if (srv.q) {
        _dogmalang.dogma.update(this, { name: "qServer", visib: ":", assign: ":=", value: ServerQServer(this, srv.q) });
      }if (srv.job) {
        _dogmalang.dogma.update(this, { name: "jobServer", visib: ":", assign: ":=", value: ServerJobServer(this, srv.job) });
      }this._props.conn = (0, _dogmalang.coalesce)(this._props.conn, {});this._props.conn.logger = (0, _dogmalang.coalesce)(this._props.conn.logger, { ["impl"]: "#dummy" });
    }
  }
};_dogmalang.dogma.mixin($ServerSuperServer, ServerDataCxnComp);
const ServerSuperServer = new Proxy($ServerSuperServer, { apply(receiver, self, args) {
    return new $ServerSuperServer(...args);
  } });module.exports = exports = ServerSuperServer;
ServerSuperServer.prototype._start = async function () {
  {
    await this._startDataCxns();for (let srv of [this._repoServer, this._eServer, this._httpServer, this._webQServer, this._qServer, this._jobServer]) {
      await this._startServer(srv);
    }this._ownHttp = (0, _dogmalang.coalesce)(this._ownHttp, _dogmalang.dogma.use(require("http-messenger"))(this._props.conn.http));
  }
};
ServerSuperServer.prototype._stop = async function () {
  {
    const errors = [];for (let srv of [this._jobServer, this._qServer, this._webQServer, this._httpServer, this._eServer, this._repoServer]) {
      {
        const [ok, err] = await _dogmalang.dogma.pawait(() => this._stopServer(srv));if (!ok) {
          _dogmalang.dogma.lshift(errors, err);
        }
      }
    }{
      const [ok, err] = await _dogmalang.dogma.pawait(() => this._stopDataCxns());if (!ok) {
        _dogmalang.dogma.lshift(errors, err);
      }
    }{
      const _ = (0, _dogmalang.len)(errors);switch (_) {case 0:
          {
            _dogmalang.dogma.nop();
          }; /* istanbul ignore next */break;case 1:
          {
            _dogmalang.dogma.raise(_dogmalang.dogma.getItem(errors, 0));
          }; /* istanbul ignore next */break;default:
          {
            _dogmalang.dogma.raise(errors);
          }}
    }
  }
};