"use strict";

var _dogmalang = require("dogmalang");

const http = _dogmalang.dogma.use(require("http"));const https = _dogmalang.dogma.use(require("https"));const connect = _dogmalang.dogma.use(require("connect"));const cookie = _dogmalang.dogma.use(require("cookie"));const send = _dogmalang.dogma.use(require("send"));const fs = _dogmalang.dogma.use(require("fs"));
const AsyncHttpServer = _dogmalang.dogma.use(require("./AsyncHttpServer"));const ConReq = _dogmalang.dogma.use(require("./ConReq"));const HttpResp = _dogmalang.dogma.use(require("./HttpResp"));
const delay = 750;
const $ConHttpServer = class ConHttpServer extends AsyncHttpServer {
  constructor(sSrv, props) {
    super(...arguments);{
      const HTTP = RegExp("^(http)://([^:]+):([0-9]+)$");const HTTPS = RegExp("^(https)://([^:]+):([0-9]+)$");const endpoints = [];const eepp = _dogmalang.dogma.paramExpected('props.endpoints', props.endpoints, [_dogmalang.list, _dogmalang.map]);if (_dogmalang.dogma.is(eepp, _dogmalang.list)) {
        for (let ep of eepp) {
          if (!HTTP.test(ep)) {
            _dogmalang.dogma.raise("invalid endpoint: %s.", ep);
          }const items = HTTP.exec(ep);_dogmalang.dogma.lshift(endpoints, { ["scheme"]: _dogmalang.dogma.getItem(items, 1), ["host"]: _dogmalang.dogma.getItem(items, 2), ["port"]: (0, _dogmalang.num)(_dogmalang.dogma.getItem(items, 3)) });
        }
      } else {
        for (let [ep, opts] of Object.entries(eepp)) {
          {
            let items;if (HTTP.test(ep)) {
              items = HTTP.exec(ep);
            } else if (HTTPS.test(ep)) {
              items = HTTPS.exec(ep);
            } else {
              _dogmalang.dogma.raise("invalid endpoint: %s.", ep);
            }_dogmalang.dogma.lshift(endpoints, { ["scheme"]: _dogmalang.dogma.getItem(items, 1), ["host"]: _dogmalang.dogma.getItem(items, 2), ["port"]: (0, _dogmalang.num)(_dogmalang.dogma.getItem(items, 3)), ["opts"]: opts });
          }
        }
      }_dogmalang.dogma.update(this, { name: "endpoints", visib: ":", assign: "=", value: endpoints }, { name: "httpServers", visib: ":", assign: ":=", value: {} }, { name: "conApp", visib: ":", assign: ":=", value: connect() });if (!this._services.__) {
        this.mount("__", _dogmalang.dogma.use(require("./JwsService")));
      }this._pvt_995c52ac06a7ca5104506278ce14efc3_configConApp();
    }
  }
};
const ConHttpServer = new Proxy($ConHttpServer, { apply(receiver, self, args) {
    return new $ConHttpServer(...args);
  } });module.exports = exports = ConHttpServer;
ConHttpServer.prototype._pvt_995c52ac06a7ca5104506278ce14efc3_configConApp = function () {
  {
    this._conApp.use(_dogmalang.dogma.use(require("cookie-parser"))({ ["secret"]: (0, _dogmalang.text)(Math.random()) }));for (let [mPoint, svc] of Object.entries(this._services)) {
      {
        {
          let publ = svc._props.static;if (publ) {
            if (_dogmalang.dogma.is(publ, _dogmalang.text)) {
              publ = { ["folder"]: publ };
            }const opts = { ["index"]: ["index.html"], ["acceptRanges"]: _dogmalang.dogma.includes(publ, "acceptRanges") ? (0, _dogmalang.bool)(publ.acceptRanges) : true, ["etag"]: _dogmalang.dogma.includes(publ, "eTag") ? (0, _dogmalang.bool)(publ.eTag) : true, ["lastModified"]: _dogmalang.dogma.includes(publ, "lastModified") ? (0, _dogmalang.bool)(publ.lastModified) : true };if (!_dogmalang.dogma.includes(publ, "cacheControl")) {
              opts.cacheControl = false;
            } else {
              opts.cacheControl = true;if (_dogmalang.dogma.is(publ.cacheControl, _dogmalang.num)) {
                opts.maxAge = publ.cacheControl * 1000;
              } else if (_dogmalang.dogma.includes(publ.cacheControl, "maxAge")) {
                opts.maxAge = publ.cacheControl.maxAge * 1000;
              }opts.immutable = _dogmalang.dogma.includes(opts.cacheControl, "immutable") ? (0, _dogmalang.bool)(opts.cacheControl.immutable) : false;
            }let staticMp = "/";if (this.mountPoint) {
              staticMp += this.mountPoint;
            }if (mPoint != "_dflt") {
              staticMp += (staticMp == "/" ? "" : staticMp) + mPoint;
            }this._conApp.use(staticMp, _dogmalang.dogma.use(require("serve-static"))(publ.folder, opts));
          }
        }
      }
    }this._conApp.use(_dogmalang.dogma.use(require("body-parser")).text());this._conApp.use(_dogmalang.dogma.use(require("body-parser")).urlencoded({ ["extended"]: false }));this._conApp.use(_dogmalang.dogma.use(require("body-parser")).json());this._conApp.use(async (req, res) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("req", req, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("res", res, null);{
        const path = req.url;const { method } = req;this._debug((0, _dogmalang.fmt)("processing %s %s...", method, path));{
          const [ok, err] = await _dogmalang.dogma.pawait(() => this._pvt_995c52ac06a7ca5104506278ce14efc3_process(req, res));if (ok) {
            this._debug((0, _dogmalang.fmt)("processed %s %s %s.", method, path, res.statusCode));
          } else {
            this._debug((0, _dogmalang.fmt)("processed %s %s. Error: %s", method, path, err));
          }
        }res.end();
      }
    });
  }
};
ConHttpServer.prototype._start = async function () {
  {
    const err = [];{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._startDataCxns());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._startServices());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._pvt_995c52ac06a7ca5104506278ce14efc3_startHttpServers());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const _ = (0, _dogmalang.len)(err);switch (_) {case 0:
          {
            _dogmalang.dogma.nop();
          }; /* istanbul ignore next */break;case 1:
          {
            _dogmalang.dogma.raise(_dogmalang.dogma.getItem(err, 0));
          }; /* istanbul ignore next */break;default:
          {
            _dogmalang.dogma.raise(err);
          }}
    }
  }
};
ConHttpServer.prototype._pvt_995c52ac06a7ca5104506278ce14efc3_startHttpServers = async function () {
  {
    for (let ep of this._endpoints) {
      const srv = ep.scheme == "https" ? https.createServer({ ["key"]: fs.readFileSync(ep.opts.key), ["cert"]: fs.readFileSync(ep.opts.cert) }, this._conApp) : http.createServer(this._conApp);await (0, _dogmalang.promise)((rslv, rej) => {
        /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
          srv.on("error", err => {
            /* istanbul ignore next */_dogmalang.dogma.paramExpected("err", err, null);{
              this._error(err);rej(err);
            }
          }).listen(ep, () => {
            {
              const dom = (0, _dogmalang.fmt)("%s://%s:%s", ep.scheme, ep.host, ep.port);_dogmalang.dogma.setItem("=", this._httpServers, dom, srv);this._info((0, _dogmalang.fmt)("started on %s.", dom));rslv();
            }
          });
        }
      });
    }
  }
};
ConHttpServer.prototype._stop = async function () {
  {
    const err = [];{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._pvt_995c52ac06a7ca5104506278ce14efc3_stopHttpServers());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._stopServices());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const [ok, e] = await _dogmalang.dogma.pawait(() => this._stopDataCxns());if (!ok) {
        _dogmalang.dogma.lshift(err, e);
      }
    }{
      const _ = (0, _dogmalang.len)(err);switch (_) {case 0:
          {
            _dogmalang.dogma.nop();
          }; /* istanbul ignore next */break;case 1:
          {
            _dogmalang.dogma.raise(_dogmalang.dogma.getItem(err, 0));
          }; /* istanbul ignore next */break;default:
          {
            _dogmalang.dogma.raise(err);
          }}
    }
  }
};
ConHttpServer.prototype._pvt_995c52ac06a7ca5104506278ce14efc3_stopHttpServers = async function () {
  {
    for (let [ep, srv] of Object.entries(this._httpServers)) {
      {
        await (0, _dogmalang.promise)((rslv, rej) => {
          /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
            let ended = false;srv.close(() => {
              {
                (0, _dogmalang.remove)(ep, this._httpServers);if (!ended) {
                  _dogmalang.dogma.pevalAnd(() => {
                    ended = true;
                  }, () => {
                    return rslv();
                  });
                }
              }
            }).unref();_dogmalang.dogma.asyncly(async () => {
              if (!ended) {
                _dogmalang.dogma.pevalAnd(() => {
                  ended = true;
                }, () => {
                  return rslv();
                });
              }
            }, delay);
          }
        });
      }
    }
  }
};
ConHttpServer.prototype._pvt_995c52ac06a7ca5104506278ce14efc3_process = async function (conReq, conResp) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("conReq", conReq, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("conResp", conResp, null);{
    let time = (0, _dogmalang.datetime)();let path = this._getPathOf(conReq.url);let svc;let rsc;if (path) {
      svc = this.getServiceOf(path);
    }if (svc) {
      path = path.replace(RegExp("^/[^/]+/?"), "/");
    } else if (path != null) {
      svc = this.defaultService;
    }if (svc) {
      rsc = svc.search(path);
    }if (!rsc) {
      conResp.statusCode = 404;conResp.setHeader("Content-Type", "text/plain");conResp.write("not found.");return;
    }if (!rsc.hasAction(conReq.method)) {
      conResp.statusCode = 405;return;
    }{
      const req = _dogmalang.dogma.getItem(_dogmalang.dogma.peval(() => {
        return ConReq(path, rsc, conReq);
      }), 1);if (_dogmalang.dogma.is(req, _dogmalang.text) && _dogmalang.dogma.like(req, "invalid param")) {
        conResp.statusCode = 409;conResp.setHeader("Content-Type", "text/plain");conResp.write(req);
      } else {
        let resp = HttpResp(req);const params = { ["req"]: req, ["resp"]: resp, ["params"]: req.params };try {
          await rsc.callInitActions(params);if (svc.db) {
            if (svc.db.pooled) {
              const cxn = params.db = await svc.db.acquire();{
                const init = cxn.__jws != null ? cxn.__jws.init : null;if (init) {
                  await init.call(params);
                }
              }
            } else {
              params.db = this.svc.db;
            }params.oper = (0, _dogmalang.proxy)(this.repo, { ["get"]: oper(params.db) });
          }await this.handle(rsc, conReq.method, time, params);await this._pvt_995c52ac06a7ca5104506278ce14efc3_send(conReq, resp, conResp);
        } catch (err) {
          resp = HttpResp(req);err = _dogmalang.dogma.is(err, _dogmalang.list) && (0, _dogmalang.len)(err) == 1 ? _dogmalang.dogma.getItem(err, 0) : err;if (_dogmalang.dogma.is(err, _dogmalang.map) && _dogmalang.dogma.is(err.status, _dogmalang.num)) {
            resp.status(err.status);if (err.msg) {
              resp.text(err.msg);
            }
          } else {
            resp.status(500);if (this.env == "dev" && err) {
              resp.text(err);
            }
          }await this._pvt_995c52ac06a7ca5104506278ce14efc3_send(conReq, resp, conResp);
        } finally {
          if (resp.serverError()) {
            this._error((0, _dogmalang.fmt)("(%s %s) %s", req.http.method, req.path, resp.c()));
          }{
            const cxn = params.db;if (cxn) {
              {
                const fin = cxn.__jws != null ? cxn.__jws.fin : null;if (fin) {
                  {
                    const [ok, err] = await _dogmalang.dogma.pawait(() => fin.call(params));if (!ok) {
                      this._error(err);
                    }
                  }
                }
              }if (cxn.release) {
                cxn.release();
              }
            }
          }
        }
      }
    }
  }
};
function oper(db) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("db", db, null);{
    return (trg, prop) => {
      let mem; /* istanbul ignore next */_dogmalang.dogma.paramExpected("trg", trg, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("prop", prop, null);{
        const val = _dogmalang.dogma.getItem(trg, prop);if (_dogmalang.dogma.isNot(val, _dogmalang.func)) {
          mem = val;
        } else {
          mem = (...args) => {
            {
              return val({ ["$db$"]: db }, ...args);
            }
          };
        }
      }return mem;
    };
  }
}
ConHttpServer.prototype._pvt_995c52ac06a7ca5104506278ce14efc3_send = function (conReq, resp, conResp) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("conReq", conReq, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("resp", resp, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("conResp", conResp, null);{
    return (0, _dogmalang.promise)((rslv, rej) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
        conResp.statusCode = resp.status();const cookies = [];for (let [name, val] of Object.entries(resp.cookies._items)) {
          {
            _dogmalang.dogma.lshift(cookies, cookie.serialize(name, (0, _dogmalang.text)(val.value), val.opts));
          }
        }if ((0, _dogmalang.len)(cookies) > 0) {
          conResp.setHeader("Set-Cookie", cookies);
        }for (let [name, val] of Object.entries(resp.headers._items)) {
          {
            conResp.setHeader(name, val);
          }
        }{
          const cType = resp.contentType();if (cType) {
            conResp.setHeader("Content-Type", cType);
          }
        }{
          const c = resp.content();if (c) {
            conResp.write(c);rslv();
          } else if (resp._fileSend) {
            const fs = resp._fileSend;conResp.setHeader("Content-Disposition", fs.filename ? (0, _dogmalang.fmt)("attachment; filename=\"%s\"", fs.filename) : "inline");const opts = { ["root"]: fs.root, ["lastModified"]: fs.lastModified, ["eTag"]: fs.eTag, ["index"]: false };{
              const cache = fs.cacheControl;if (cache) {
                opts.cacheControl = true;opts.maxAge = cache.maxAge;opts.immutable = cache.immutable;
              }
            }send(conReq, resp._fileSend.path, opts).on("end", err => {
              {
                if (err) {
                  rej(err);
                } else {
                  rslv();
                }
              }
            }).pipe(conResp);
          } else {
            rslv();
          }
        }
      }
    });
  }
};