"use strict";

var _dogmalang = require("dogmalang");

const HttpMsg = _dogmalang.dogma.use(require("./HttpMsg"));const HttpReq = _dogmalang.dogma.use(require("./HttpReq"));
const $HttpResp = class HttpResp extends HttpMsg {
  constructor(req) {
    /* istanbul ignore next */_dogmalang.dogma.paramExpected("req", req, HttpReq);super(req.resource);{
      _dogmalang.dogma.update(_dogmalang.dogma.update(this, { name: "req", visib: ".", assign: "=", value: req }), { name: "status", visib: ":", assign: "=", value: null }, { name: "contentType", visib: ":", assign: "=", value: null }, { name: "content", visib: ":", assign: "=", value: null }, { name: "ended", visib: ":", assign: "=", value: false }, { name: "fileSend", visib: ":", assign: "=", value: null });
    }
  }
};
const HttpResp = new Proxy($HttpResp, { apply(receiver, self, args) {
    return new $HttpResp(...args);
  } });module.exports = exports = HttpResp;
HttpResp.prototype.ended = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._ended;
    } else {
      this._ended = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.bool);rslt = this;
    }
  }return rslt;
};
HttpResp.prototype.status = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._status || this.resource.status() || 200;
    } else {
      this._status = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.num);rslt = this;
    }
  }return rslt;
};
HttpResp.prototype.success = function () {
  {
    return _dogmalang.dogma.like(this.status(), "^2");
  }
};
HttpResp.prototype.clientError = function () {
  {
    return _dogmalang.dogma.like(this.status(), "^4");
  }
};
HttpResp.prototype.serverError = function () {
  {
    return _dogmalang.dogma.like(this.status(), "^5");
  }
};
HttpResp.prototype.error = function () {
  {
    return this.clientError() || this.serverError();
  }
};
HttpResp.prototype.contentType = function (...args) {
  let rslt;{
    if ((0, _dogmalang.len)(args) == 0) {
      rslt = this._contentType || this.resource.contentType();
    } else {
      this._contentType = _dogmalang.dogma.paramExpected('dogma.getItem(args, 0)', _dogmalang.dogma.getItem(args, 0), _dogmalang.text);rslt = this;
    }
  }return rslt;
};
HttpResp.prototype.cType = function (...args) {
  {
    return this.contentType(...args);
  }
};
HttpResp.prototype.content = function (...args) {
  {
    let cType;let c;{
      const _ = (0, _dogmalang.len)(args);switch (_) {case 0:
          {
            return this._content;
          }; /* istanbul ignore next */break;case 1:
          {
            c = _dogmalang.dogma.getItem(args, 0);
          }; /* istanbul ignore next */break;default:
          {
            [cType, c] = _dogmalang.dogma.getArrayToUnpack(args, 2);
          }}
    }if (cType) {
      this.contentType(cType);
    }_dogmalang.dogma.update(this, { name: "content", visib: ":", assign: "=", value: c });return this;
  }
};
HttpResp.prototype.c = function (...args) {
  {
    return this.content(...args);
  }
};
HttpResp.prototype.text = function (...args) {
  {
    return this.content("text/plain", (0, _dogmalang.len)(args) > 1 ? (0, _dogmalang.fmt)(...args) : (0, _dogmalang.text)(_dogmalang.dogma.getItem(args, 0)));
  }
};
HttpResp.prototype.markdown = function (...args) {
  {
    return this.content("text/markdown", (0, _dogmalang.len)(args) > 1 ? (0, _dogmalang.fmt)(...args) : (0, _dogmalang.text)(_dogmalang.dogma.getItem(args, 0)));
  }
};
HttpResp.prototype.md = function (...args) {
  {
    return this.markdown(...args);
  }
};
HttpResp.prototype.json = function (val) {
  {
    return this.content("application/json", _dogmalang.json.encode(val));
  }
};
HttpResp.prototype.html = function (c) {
  {
    return this.content("text/html", (0, _dogmalang.text)(c));
  }
};
HttpResp.prototype.file = function (fPath, opts) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("fPath", fPath, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpectedToHave("opts", opts, { root: { type: _dogmalang.text, mandatory: false }, filename: { type: _dogmalang.text, mandatory: false }, eTag: { type: _dogmalang.bool, mandatory: false }, cacheControl: { type: [_dogmalang.num, _dogmalang.map], mandatory: false }, lastModified: { type: _dogmalang.bool, mandatory: false } }, false);{
    opts = (0, _dogmalang.coalesce)(opts, {});this._fileSend = { ["path"]: fPath, ["root"]: opts.root, ["filename"]: opts.filename, ["eTag"]: _dogmalang.dogma.includes(opts, "eTag") ? (0, _dogmalang.bool)(opts.eTag) : true, ["lastModified"]: _dogmalang.dogma.includes(opts, "lastModified") ? (0, _dogmalang.bool)(opts.lastModified) : true };{
      const opt = opts.cacheControl;if (opt) {
        const cache = this._fileSend.cacheControl = {};if (_dogmalang.dogma.is(opt, _dogmalang.num)) {
          cache.maxAge = opt * 1000;
        } else if (_dogmalang.dogma.is(opt, _dogmalang.map)) {
          if (_dogmalang.dogma.is(opt.maxAge, _dogmalang.num)) {
            cache = opt.maxAge * 1000;
          }cache.immutable = _dogmalang.dogma.includes(opt.cacheControl, "immutable") ? (0, _dogmalang.bool)(opt.immutable) : false;
        }
      }
    }
  }
};
HttpResp.prototype.redirectTo = function (uri, status) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("uri", uri, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpectedToBe("status", status, _dogmalang.num);{
    if (status) {
      this.status(status);
    } else if (!this._status) {
      this.status(302);
    }this.headers.set("location", uri);
  }return this;
};