"use strict";

var _dogmalang = require("dogmalang");

var _ws = require("ws");

const AsyncWebQServer = _dogmalang.dogma.use(require("./AsyncWebQServer"));const Headers = _dogmalang.dogma.use(require("./Headers"));
const EP_PTN = RegExp("^ws://(.+):([0-9]+)$");
const $WsWebQServer = class WsWebQServer extends AsyncWebQServer {
  constructor(sSrv, props) {
    super(...arguments);{
      for (let ep of _dogmalang.dogma.paramExpected('props.endpoints', props.endpoints, _dogmalang.list)) {
        if (!EP_PTN.test(ep)) {
          _dogmalang.dogma.raise("invalid endpoint: %s.", ep);
        }
      }_dogmalang.dogma.update(this, { name: "ws", visib: ":", assign: "=", value: null }, { name: "consumers", visib: ":", assign: ":=", value: {} });
    }
  }
};
const WsWebQServer = new Proxy($WsWebQServer, { apply(receiver, self, args) {
    return new $WsWebQServer(...args);
  } });module.exports = exports = WsWebQServer;
WsWebQServer.prototype._start = async function () {
  {
    await this._startDataCxns();await this._pvt_a65e8cb738ad6bb63a259972415b145c_startWsServer();await this._startServices();await this._pvt_a65e8cb738ad6bb63a259972415b145c_subscribeToQueues();this.q.on("msg", async (q, msg) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("q", q, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("msg", msg, null);{
        {
          const [ok, err] = await _dogmalang.dogma.pawait(() => this._pvt_a65e8cb738ad6bb63a259972415b145c_processQMsg(q, msg));if (!ok) {
            this._debug(err);
          }
        }
      }
    });
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_startWsServer = function () {
  {
    return (0, _dogmalang.promise)((rslv, rej) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
        let opts;const [host, port] = _dogmalang.dogma.getArrayToUnpack(_dogmalang.dogma.getSlice(EP_PTN.exec(_dogmalang.dogma.getItem(this._props.endpoints, 0)), 1, 2), 2);opts = { ["host"]: host, ["port"]: port };let cxn = false;(this._ws = new _ws.Server(opts)).on("connection", (cli, iReq) => {
          /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("iReq", iReq, null);{
            const req = { ["headers"]: Headers(iReq.headers) };cli.on("message", (...args) => {
              {
                this._pvt_a65e8cb738ad6bb63a259972415b145c_processRcvdMsg(cli, req, _dogmalang.dogma.getItem(args, 0));
              }
            }).on("close", () => {
              {
                this._pvt_a65e8cb738ad6bb63a259972415b145c_removeWsClient(cli);
              }
            });
          }
        }).on("listening", () => {
          {
            cxn = true;rslv();
          }
        }).on("error", err => {
          {
            /*istanbul ignore next*/if (!cxn) {
              rej(err);
            }
          }
        });
      }
    });
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_removeWsClient = function (cli) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null);{
    for (let q of (0, _dogmalang.keys)(this._consumers)) {
      this._pvt_a65e8cb738ad6bb63a259972415b145c_unsubscribe(cli, q);
    }
  }
};
WsWebQServer.prototype._stop = async function () {
  {
    await _dogmalang.dogma.pawait(() => this._stopServices());await _dogmalang.dogma.pawait(() => this._pvt_a65e8cb738ad6bb63a259972415b145c_stopWsServer());await _dogmalang.dogma.pawait(() => this._stopDataCxns());
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_stopWsServer = function () {
  {
    return (0, _dogmalang.promise)((rslv, rej) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
        this._ws.close(() => {
          {
            _dogmalang.dogma.pevalAnd(() => {
              this._ws = null;
            }, () => {
              return rslv();
            });
          }
        });
      }
    });
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_subscribeToQueues = function () {
  {
    return (0, _dogmalang.promise)((rslv, rej) => {
      /* istanbul ignore next */_dogmalang.dogma.paramExpected("rslv", rslv, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("rej", rej, null);{
        const qq = [];for (let [_, svc] of Object.entries(this._services)) {
          {
            for (let q of (0, _dogmalang.keys)(svc._auths)) {
              _dogmalang.dogma.lshift(qq, q);
            }
          }
        }this.q.subscribeTo(qq).then(rslv, rej);
      }
    });
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_processQMsg = async function (q, msg) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("q", q, _dogmalang.text); /* istanbul ignore next */_dogmalang.dogma.paramExpected("msg", msg, null);{
    for (let c of _dogmalang.dogma.getItem(this._consumers, q) || []) {
      c.send(_dogmalang.json.encode({ ["type"]: "msg", ["q"]: q, ["msg"]: msg }));
    }
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_processRcvdMsg = function (cli, req, msg) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("req", req, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("msg", msg, _dogmalang.text);try {
    const cmd = this._buildCmd(_dogmalang.json.decode(msg));{
      const svc = this.getServiceOf(cmd.svc);if (svc) {
        {
          const auth = svc.search(cmd.q);if (auth) {
            this.handle(auth, "auth", (0, _dogmalang.datetime)(), { ["msg"]: cmd, ["req"]: req }).then(() => {
              {
                {
                  const _ = cmd.type;switch (_) {case "pub":
                      {
                        this._pvt_a65e8cb738ad6bb63a259972415b145c_processPubMsg(cli, cmd);
                      }; /* istanbul ignore next */break;case "sub":
                      {
                        this._pvt_a65e8cb738ad6bb63a259972415b145c_processSubMsg(cli, cmd);
                      }; /* istanbul ignore next */break;default:
                      {
                        this._pvt_a65e8cb738ad6bb63a259972415b145c_processUnsubMsg(cli, cmd);
                      }}
                }
              }
            }, err => {
              /* istanbul ignore next */_dogmalang.dogma.paramExpected("err", err, null);{
                if (cli.readyState == 1) {
                  cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "error", ["msg"]: (0, _dogmalang.text)(err) }));
                }
              }
            });
          } else {
            cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "error", ["msg"]: (0, _dogmalang.fmt)("unknown authorizer: %s.", cmd.q) }));
          }
        }
      } else {
        cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "error", ["msg"]: (0, _dogmalang.fmt)("unknown service: %s.", cmd.svc) }));
      }
    }
  } catch (e) {
    if (_dogmalang.dogma.like(e, "Unexpected token") || _dogmalang.dogma.like(e, "invalid queue:.+\\. It must be like service/queue\\.")) {
      if (cli.readyState == 1) {
        cli.send(_dogmalang.json.encode({ ["type"]: "resp", ["status"]: "error", ["msg"]: "invalid command." }));
      }
    }
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_processSubMsg = function (cli, cmd) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("cmd", cmd, null);{
    if (!_dogmalang.dogma.getItem(this._consumers, cmd.q)) {
      _dogmalang.dogma.setItem("=", this._consumers, cmd.q, []);
    }{
      const cc = _dogmalang.dogma.getItem(this._consumers, cmd.q);if (_dogmalang.dogma.includes(cc, cli)) {
        cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "ok" }));
      } else {
        this.q.subscribeTo(cmd.q).then(() => {
          {
            _dogmalang.dogma.lshift(cc, cli);cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "ok" }));
          }
        }, err => {
          {
            /*istanbul ignore next*/cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "error", ["msg"]: (0, _dogmalang.text)(err) }));
          }
        });
      }
    }
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_processUnsubMsg = function (cli, cmd) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("cmd", cmd, null);{
    this._pvt_a65e8cb738ad6bb63a259972415b145c_unsubscribe(cli, cmd.q);cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "ok" }));
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_unsubscribe = function (cli, q) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("q", q, _dogmalang.text);{
    {
      const cons = _dogmalang.dogma.getItem(this._consumers, q);if (cons) {
        (0, _dogmalang.remove)(cli, cons); /*istanbul ignore else*/if ((0, _dogmalang.len)(cons) == 0) {
          (0, _dogmalang.remove)(q, this._consumers);this.q.unsubscribeFrom(q).then(_dogmalang.dogma.nop(), _dogmalang.dogma.nop());
        }
      }
    }
  }
};
WsWebQServer.prototype._pvt_a65e8cb738ad6bb63a259972415b145c_processPubMsg = function (cli, cmd) {
  /* istanbul ignore next */_dogmalang.dogma.paramExpected("cli", cli, null); /* istanbul ignore next */_dogmalang.dogma.paramExpected("cmd", cmd, null);{
    this.q.publish(cmd.msg, cmd.q).then(() => {
      {
        cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "ok" }));
      }
    }, err => {
      {
        /*istanbul ignore next*/cli.send(_dogmalang.json.encode({ ["id"]: cmd.id, ["type"]: "resp", ["status"]: "error", ["msg"]: (0, _dogmalang.text)(err) }));
      }
    });
  }
};